#include "StdAfx.h"

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <TCHAR.H>
#include <direct.h>

static HANDLE MY_MUTEX;

void DeletingPathDivide(LPCTSTR src, LPTSTR dest)
{
	while( *src++ ) if( *src != _TEXT('\\') ) *dest = *src;
	*dest = _TEXT('\0');
}

bool MyEnterCriticalSection(LPCTSTR file)
{
	TCHAR MUTEX_NAME[_MAX_PATH+1];
	int i = 0, fd = -1;

	DeletingPathDivide(file, MUTEX_NAME);

	_tcscat(MUTEX_NAME,_TEXT("_MUTEX"));

	MY_MUTEX = CreateMutex(NULL, true, MUTEX_NAME);

	if( MY_MUTEX == NULL ) return false; // not create or obtain mutex object

	if(	GetLastError() == ERROR_ALREADY_EXISTS )
	{
		//MessageBox(NULL,"get ok","ok",0);
		DWORD ret = WaitForSingleObject(MY_MUTEX, 300000);	// wait for 5 minutes

		if( ret == WAIT_TIMEOUT || ret == WAIT_FAILED )		// failed to obtain ownership
		{
			//MessageBox(NULL,"false","ok",0);
			CloseHandle( MY_MUTEX );
			return false;
		}
	}
	//MessageBox(NULL,"create ok","ok",0);
	return true;
}

void MyEndCriticalSection( void )
{
	ReleaseMutex(MY_MUTEX);
	
	CloseHandle(MY_MUTEX);	// The mutex object is destroyed when its last handle has been closed
}