#include "StdAfx.h"

#include "SimiyFindFile.h"
#include "SimiyUtil.h"
#include <stdio.h>
#include <string.h>
#include <direct.h>

CSimiyFindFile::CSimiyFindFile()
{
	m_Handle = INVALID_HANDLE_VALUE;
	m_bCurValidFindData = false;
}

CSimiyFindFile::~CSimiyFindFile()
{
	if( m_Handle != INVALID_HANDLE_VALUE )	CloseHandle( m_Handle );
}

LPCTSTR CSimiyFindFile::GetFirst(LPCTSTR searchPattern)
{
	if( m_Handle != INVALID_HANDLE_VALUE )	CloseHandle( m_Handle );

	this->m_bCurValidFindData = false;

	m_Handle = FindFirstFile( searchPattern, &m_FindData );

	if( m_Handle == INVALID_HANDLE_VALUE )
	{
		return NULL;
	}

	GetDirName(searchPattern, this->m_CurSearchFolder);

	this->m_bCurValidFindData = true;
	return (LPCTSTR)m_FindData.cFileName;
}

LPCTSTR CSimiyFindFile::GetNext()
{
	if( ! this->m_bCurValidFindData )
		return NULL;
	if( ! FindNextFile(m_Handle, &m_FindData) )	// not found
	{
		m_bCurValidFindData = false;
		return NULL;
	}

	return (LPCTSTR)m_FindData.cFileName;
}

void CSimiyFindFile::DeleteCurrent()
{
	if( ! m_bCurValidFindData ) return;

	_stprintf(this->m_TmpPath, "%s%s", this->m_CurSearchFolder, m_FindData.cFileName);

	if( m_FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
		_trmdir( m_TmpPath );
	else
		_tunlink( m_TmpPath );
}
void CSimiyFindFile::RenameCurrent(LPCTSTR destName)
{
	if( ! m_bCurValidFindData ) return;

	_stprintf(this->m_TmpPath, "%s%s", this->m_CurSearchFolder, m_FindData.cFileName);

	_trename( m_TmpPath, destName );
}
void CSimiyFindFile::DeleteAll()
{
	if( ! m_bCurValidFindData ) return;
	
	do
	{
		_stprintf(this->m_TmpPath, "%s%s", this->m_CurSearchFolder, m_FindData.cFileName);

		if( m_FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
			_trmdir( m_TmpPath );
		else
			_tunlink( m_TmpPath );

	} while (FindNextFile(m_Handle, &m_FindData));

	m_bCurValidFindData = false;
}
