#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <direct.h>
#include <sys/stat.h>
#include <winbase.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>
#include <TCHAR.h>

#include "SimiyUtil.h"

bool FileExist(LPCTSTR path) {
	int fd = _topen(path, _O_RDONLY);
	if( fd < 0 ) return false;
	_close(fd);
	return true;
}

void GetDirName(LPCTSTR FilePath, LPTSTR retStr) {
	TCHAR drive[_MAX_DRIVE+_MAX_DIR+1], dir[_MAX_DIR+1];
	_tsplitpath(FilePath, drive, dir, NULL, NULL);
	_tcscat(drive, dir);
	
	_tcscpy(retStr,drive);
}

void GetFileName(LPCTSTR FilePath, LPTSTR retStr) {
	TCHAR file[_MAX_FNAME+_MAX_EXT+1], ext[_MAX_EXT+1];
	_tsplitpath(FilePath, NULL, NULL, file, ext);
	_tcscat(file, ext);
	_tcscpy(retStr,file);
}

void GetExtName(LPCTSTR FilePath, LPTSTR retStr) {
	TCHAR ext[_MAX_EXT+1];
	_tsplitpath(FilePath, NULL, NULL, NULL, ext);
	_tcscpy(retStr,ext);
}

void GetDirDivide(LPCTSTR FilePath, LPTSTR ParentPath, LPTSTR CurDirName)
{
	TCHAR tmpName[_MAX_PATH];

	GetDirName(FilePath, tmpName);

	TCHAR *pChar;
	if( (pChar = _tcsrchr( tmpName, '\\' )) )	// delete '\\'
	{
		*pChar = '\0';
	}

	GetDirName(tmpName, ParentPath);	// release parent dir
	GetFileName(tmpName, CurDirName);	// release name
}

long file_size(LPCTSTR file )
{
	long ret_size = 0;
	int fd = _topen(file, _O_RDONLY );
	if( fd >= 0 ) {
		ret_size = _filelength(fd);
		_close(fd);
	}
	return (ret_size < 0 ? 0 : ret_size);
}

LPCTSTR TimeConvert(long timeLong)
{
	static TCHAR timeString[12];
	long h, m, s;

	if(timeLong <= 0) h = m = s = 0;
	else
	{
		h = timeLong / (60 * 60);
		m = (timeLong - (h * 60 * 60)) / (60);
		s = (timeLong - ((h * 60 + m) * 60));

		_stprintf(timeString,"%02d:%02d:%02d", h, m, s);
	}

	return timeString;
}

long TimeConvert(LPCTSTR timeString)
{
	short h, m, s;
	h = m = s = 0;

	_stscanf(timeString, "%02d:%02d:%02d", &h, &m, &s);
	
	return (long)((((h*60)+m)*60)+s);
}

LPCTSTR ByteToStr(double ByteCount)
{
	TCHAR szFormatters[4][3] = {"KB", "MB", "GB", "TB"};
	int nNumConversions = 0;
	static TCHAR SizeStr[32];

	ByteCount /= 1024;
	while (ByteCount >= 1024 && nNumConversions < 3 ) {
	   ByteCount /= 1024;
	   nNumConversions++;
	}
	TCHAR *strUnits = szFormatters[nNumConversions];

	_stprintf(SizeStr, "%.1f%s", ByteCount, strUnits);

	return SizeStr;
}

LPCTSTR KByteToStr(double KByte)
{
	TCHAR szFormatters[4][3] = {"KB", "MB", "GB", "TB"};
	int nNumConversions = 0;
	static TCHAR SizeStr[32];

	while (KByte >= 1024 && nNumConversions < 3 ) {
	   KByte /= 1024;
	   nNumConversions++;
	}
	TCHAR *strUnits = szFormatters[nNumConversions];

	if( nNumConversions == 0 )
	{
		_stprintf(SizeStr, "%.0f%s", KByte, strUnits);

	}
	else
	{
		_stprintf(SizeStr, "%.1f%s", KByte, strUnits);
	}

	return SizeStr;
}

LPCTSTR GetDateTime()
{
	long ret;
	static TCHAR _buf[32];

	time(&ret);
	struct tm *pTm = localtime( &ret );

	ret = _stprintf(_buf, "%04d/%02d/%02d %02d:%02d:%02d",
		pTm->tm_year + 1900, pTm->tm_mon + 1, pTm->tm_mday,
		pTm->tm_hour, pTm->tm_min, pTm->tm_sec);
	return _buf;
}

void ReplaceString(LPTSTR source, LPCTSTR pattern, LPCTSTR replace)
{
	static TCHAR str[512];
	TCHAR *pChar;

	pChar = _tcsstr(source, pattern);
	if(pChar != NULL)
	{
		_tcscpy(str, pChar + _tcslen(pattern));
		_tcscpy(pChar, replace);
		_tcscat(source, str);
	}
}

/*
unsigned long size_sfvfiles( LPCTSTR sfv_file )
{
	TCHAR buf[512];
	FILE *sfvfile = _tfopen(sfv_file, "rb");
	if(sfvfile == NULL) return 0;

	unsigned long ret_size = 0;

	TCHAR path[_MAX_PATH];

	GetDirName(sfv_file, path);

	CRegExp reLine;

	if (reLine.RegComp("^[ \t]*([^;]+)[ \t]+([a-zA-Z0-9]+)") == NULL)
	{
		//AfxMessageBox("RegExp error");
		return 0;
	}

	while( _fgetts(buf, 1023, sfvfile) )
	{
		TCHAR filepath[_MAX_PATH];

		if(reLine.RegFind( buf ) < 0) continue;

		char *filename = reLine.GetReplaceString("\\1");

		_stprintf(filepath, "%s%s", path, filename);

		delete [] filename;

		ret_size += file_size(filepath);
	}
	fclose(sfvfile);

	return (ret_size);
}
*/

void LTrim(LPTSTR src)
{
	TCHAR *ptr = src;

	while( _istspace(*ptr) ) *ptr++;

	if( ptr == src ) return;

	while( *ptr ) *src++ = *ptr++;
	*src = _TEXT('\0');
}

void RTrim(LPTSTR src)
{
	while( *src ) *src++;
	while( (*src == _TEXT('\0')) || _istspace(*src) ) *src--;
	*++src = _TEXT('\0');
}

TCHAR FirstLChar(LPCTSTR src)
{
	while( _istspace(*src) ) *src++;

	return *src;
}

static int CRC16(char *ansiFname)
{
	long crc = 0xffff;
	int  length;
	long _POLY=0x8468;

	if( (length = strlen( ansiFname )) == 0 ) return 0;
	
	_strlwr(ansiFname);

	unsigned short data;

	for (int i = 0; i < length; i++ )
	{
		data = 0xff & (unsigned short)ansiFname[i];
		for (int j=0; j < 8; j++ )
		{
			if ((crc & 0x0001) ^ (data & 0x0001))
			{
				crc = ((crc >> 1) ^ _POLY);
			}
			else
			{
				crc >>= 1;
			}
			data >>= 1;
		}
	}
	crc = crc^0xFFFF;
	crc = ((crc & 0xff) << 8) | ((crc >> 8) & 0xff);
	return crc;
}

static int CheckSum(char *ansiFname)
{
	long crc = 0xffff;
	int  length;

	if( (length = strlen( ansiFname )) == 0 ) return 1;

	_strlwr(ansiFname);

	long avg = 0;
	for(int j = 0 ; j < length ; j++)
	{
		avg += (unsigned short)ansiFname[j];
	}
	return (int)(avg%32768);
}

unsigned long getFileID(LPCTSTR filename)
{
	char ansiFname[_MAX_FNAME];

#ifdef _UNICODE
	W2A( filename, ansiFname, _MAX_FNAME );
#else
	strcpy( ansiFname, filename );
#endif

	unsigned long crc16		= CRC16(ansiFname);
	unsigned long checksum	= CheckSum(ansiFname);

	return (unsigned long)((crc16 * pow(2,16))+checksum);
}
