#include "StdAfx.h"

#include "SimiyVPair.h"
#include "SimiyUtil.h"

CSimiyVPair	SimiyVPair;

CSimiyVPair::CSimiyVPair()
{
	m_VPair = new CLinkedList( sizeof( VPairNode ) );
}

CSimiyVPair::~CSimiyVPair ()
{
	delete m_VPair;
}

void CSimiyVPair::InitVPair()
{
	for(VPairNode *node = (VPairNode *)m_VPair->dltofirst();
		node;
		node = (VPairNode *)m_VPair->dlget() )
	{
		m_VPair->dldelete();
	}
}

void CSimiyVPair::AddPair(LPCTSTR variable, LPCTSTR value)
{
	VPairNode node;

	_tcscpy(node.variable, variable);
	_tcscpy(node.value, value);
	node.variable_length = _tcslen(variable);

	m_VPair->dladd( &node );
}
void CSimiyVPair::ReplacePair(LPCTSTR variable, LPCTSTR value)
{
	VPairNode newNode;

	_tcscpy(newNode.variable, variable);
	_tcscpy(newNode.value, value);
	newNode.variable_length = _tcslen(variable);

	for(VPairNode *node = (VPairNode *)m_VPair->dltofirst();
		node && ! _tcscmp(newNode.variable, node->variable);
		node = (VPairNode *)m_VPair->dlgofwd() )
	{
		m_VPair->dlreplace( &newNode );
	}
	if( ! node ) m_VPair->dladd( &newNode );
}
void CSimiyVPair::AddPairs(int pair_count, ... )
{
	LPCTSTR	variable, value;
	va_list args;

	va_start(args, pair_count);
	for(int i=0; i<pair_count; i++)
	{
		variable = va_arg( args, LPCTSTR);
		value = va_arg( args, LPCTSTR);
		this->AddPair(variable, value);
	}
	va_end(args);
}

const VPairNode *CSimiyVPair::FindVPairNode(LPCTSTR variableStartString)
{
	int length = _tcslen(variableStartString);
	for(VPairNode *node = (VPairNode *)m_VPair->dltofirst();
		node;
		node = (VPairNode *)m_VPair->dlgofwd() )
	{
		if( length > node->variable_length &&
			! _tcsncmp(variableStartString+1, node->variable, node->variable_length)
			)
			return node;
	}
	return NULL;
}

void CSimiyVPair::ParsingTemplet(LPCTSTR templet, LPTSTR retStr)
{
	int length = _tcslen(templet);
	const VPairNode *node;

	int j=0;
	for(int i=0; i < length; i++)
	{
		if( templet[i] == _T('$') )
		{
			node = this->FindVPairNode( &(templet[i]) );
			if( node ) {
				_tcscpy( &(retStr[j]), node->value );
				j += _tcslen(node->value);
				i += node->variable_length;	// $variable_name <= +1 = for(...;i++) 
				continue;
			}
		}
		retStr[j++]=templet[i];
	}
	retStr[j] = _T('\0');
}
